/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Objeto_h
#define Objeto_h

#include "Mapa.h"

// Constantes de las direcciones
#define IZQ 1
#define DER 2
#define ARR 3
#define ABA 4

/**
 * Clase que controla las reglas de movimiento para las cajas.
 */
class Caja {

  public:
    // Constructor y destructor
    Caja();
    virtual ~Caja();

    // Mueve la caja una posicion hacia la direccion indicada
    int mover(int dir);

    // Controla el movimiento de la caja
    virtual int controlarMovimiento();

  public:
    int casX;     // Posicion X en el casillero donde esta la caja
    int casY;     // Posicion Y en el casillero donde esta la caja
    int moviendo; // Direccion hacia donde se mueve actualmente

};
#endif
