/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "Casilla.h"
#include "Sistema.h"

/**
 * Constructor de la clase Casilla
 * @param ficheroImagen Nombre del fichero que contiene la imagen de la casilla.
 */
Casilla::Casilla(char *ficheroImagen) : Widget (0,0,0,ficheroImagen)
{

}

/**
 * Destructor de la clase casilla
 */
Casilla::~Casilla()
{

}

/**
 * Dibuja la casilla indicando su posicion.
 * @param x Posicion horizontal
 * @param y Posicion vertical
 */
void Casilla::dibujar(int x, int y)
{
  // Alinear la imagen en la casilla
  cuadro->x = x;
  cuadro->y = y - (cuadro->al-30);

  // El metodo padre la dibuja
  Widget::dibujar();
}

/**
 * Detecta el estado del raton sobre la casilla indicando su posicion.
 * Util para comprobarla antes de dibujarla.
 * @return MSG_DETECTADO_RATON si se ha detectado el raton.
 * @return MSG_RATON_CLICK si el raton esta pulsado sobre el widget
 */
DWORD Casilla::detectarRaton(int x, int y)
{
  int msg;
  // Alinear la imagen en la casilla
  cuadro->x = x;
  cuadro->y = y - (cuadro->al-30);

  // El metodo padre detecta el raton
  msg = Widget::detectarRaton();

  // Y devolver el resultado*/
  return msg;
}

