/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CuadroTexto_h
#define CuadroTexto_h

#include "Widget.h"

#define DF_COLORFONDOCT   0xFFFFFF
#define DF_COLORBORDECT   0x000001
#define DF_COLORTEXTOCT   0x000001
#define DF_FLAGSCT        0

// ## A hacer: Hacer que el texto del cuadro se dibuje como el titulo del boton
// heredando el atributo texto.

/**
 * Clase CuadroTexto heredada de Widget
 * Controla los cuadros de texto que aparecen en las ventanas
 * Comprueba la entrada de teclado (si posee el foco) y modifica el texto
 * que contiene con lo que introduce el usuario
 */
class CuadroTexto : public Widget {

  public:
    // Constructor y destructor
    CuadroTexto(CUADRO** cuadroPadre, int x, int y,
                int ancho, int alto, int maxLetras);
    virtual ~CuadroTexto();

    // Cadena con el texto que hay escrito actualmentes
    char* textoEscrito;

    // Cambia el texto por el indicado
    void cambiarTexto(char* cadena);

  public:
    // Dibuja el cuadro de texto
    void dibujar();

    // Flag que indica si el texto ha sido cambiado
    int cambiado;

  private:
    // Numero de caracteres que caben en el cuadro de texto
    int longitud;

    // Posicion actual del cursor
    int posicionActual;

    // Flag que indica si se ha vaciado el buffer del teclado
    int bufferCero;
};

#endif
