/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>

#include "Sistema.h"
#include "Menu.h"

/**
 * Constructor de la clase Menu
 */
Menu::Menu(){
#ifdef DEBUG
  puts("Inicializando Menu");
#endif

  // Cargar imagen de fondo del menu
  fondo=new Imagen(0,0,0,"img/menufondo.bmp");

  opcion=0;
  marcar=0;
}


/**
 * Destructor de la clase menu
 */
Menu::~Menu(){

  if (fondo)                    delete fondo;

  for (int i=0;i<nTextos;i++)   delete texto[i];
}

/**
 * Actualiza la pantalla del menu
 */
void Menu::actualizarPantalla()
{

  marcar=0;

  // Mostrar imagen de fondo del menu
  fondo->dibujar();
  //texto[TXT_TITULO]->centrar(texto[TXT_TITULO]->flags);

  texto[TXT_TITULO]->dibujar();

  texto[TXT_OPC1]->dibujar();
  texto[TXT_OPC2]->dibujar();
  texto[TXT_OPC3]->dibujar();
  texto[TXT_OPC4]->dibujar();
  texto[TXT_OPC5]->dibujar();

}

/**
 * Comprueba que opcion elige el usuario (por teclado o raton)
 */
void Menu::comprobarEntrada(){
  opcion=0;
  if (Sistema::comprobarTeclado(TECLA_ESC))    opcion=OPC_SALIR;

  // Comprobar teclas
  if (Sistema::comprobarTeclado(TECLA_1))      opcion=OPC_JUGAR;
  if (Sistema::comprobarTeclado(TECLA_2))      opcion=OPC_CONTINUAR;
  if (Sistema::comprobarTeclado(TECLA_3))      opcion=OPC_EDITOR;
  if (Sistema::comprobarTeclado(TECLA_4))      opcion=OPC_RECORDS;
  if (Sistema::comprobarTeclado(TECLA_5))      opcion=OPC_SALIR;
  if (Sistema::comprobarTeclado(TECLA_ESC))    opcion=OPC_SALIR;

  if (texto[TXT_OPC1]->detectarRaton()==MSG_RATON_CLICK)  opcion=OPC_JUGAR;
  if (texto[TXT_OPC2]->detectarRaton()==MSG_RATON_CLICK)  opcion=OPC_CONTINUAR;
  if (texto[TXT_OPC3]->detectarRaton()==MSG_RATON_CLICK)  opcion=OPC_EDITOR;
  if (texto[TXT_OPC4]->detectarRaton()==MSG_RATON_CLICK)  opcion=OPC_RECORDS;
  if (texto[TXT_OPC5]->detectarRaton()==MSG_RATON_CLICK)  opcion=OPC_SALIR;

  Programa::comprobarEntrada();
}

/**
 * Comprueba el estado del menu (termina si se ha elegido una opcion)
 */
void Menu::comprobarEstado(){
  m_salir = opcion;
  Programa::comprobarEstado();
}
