/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Personaje_h
#define Personaje_h

#include "Caja.h"

/**
 * Clase que controla las reglas de movimiento para el personaje.
 */
class Personaje : public Caja {

  public:
    // Constructor y destructor
    Personaje(Caja** caja, int nCajas);
    virtual ~Personaje();

    // Mueve el personaje hacia la direccion indicada
    int mover(int dir);

    // Mueve el personaje por raton hacia el destino indicado
    int moverR(int x, int y);

    // Controla el movimiento del personaje
    int controlarMovimiento();

  public:
    // Cajas del escenario
    Caja**  caja;
    int     nCajas;

    // Destino actual del personaje hacia donde se mueve
    int destinoX;
    int destinoY;

  private:
    // Detecta si hay una caja en una posicion indicada
    Caja* detectarCaja(int x, int y);

};
#endif
