/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Texto_h
#define Texto_h

#include "Widget.h"

#define FICHERO_TEXTOS "nfo/textos.lng"

#define DF_FUENTE 0

// Macros para identificar los textos que se escriben en el menu
#define TXT_TITULO  0
#define TXT_OPC1    1
#define TXT_OPC2    2
#define TXT_OPC3    3
#define TXT_OPC4    4
#define TXT_OPC5    5

// Macros para identificar los textos que se escriben en todo el programa
#define TXT_SOKONUX       texto[6]
#define TXT_SALIR         texto[7]
#define TXT_ACEPTAR       texto[8]
#define TXT_CANCELAR      texto[9]
#define TXT_ABANDONAR     texto[10]
#define TXT_CONTINUAR     texto[11]
#define TXT_PASSWORD      texto[12]
#define TXT_NOPASSWORD    texto[13]
#define TXT_GUARDAR       texto[14]
#define TXT_CONFGUARDAR   texto[15]
#define TXT_ERROR         texto[16]
#define TXT_NOGUARDADO    texto[17]
#define TXT_GUARDADO      texto[18]
#define TXT_INTRNUMERO    texto[19]
#define TXT_CARGAR        texto[20]
#define TXT_NOCARGADO     texto[21]
#define TXT_HERRAMIENTAS  texto[22]
#define TXT_ARCHIVO       texto[23]
#define TXT_NUEVO         texto[24]
#define TXT_PROPIEDADES   texto[25]
#define TXT_PUNTOSEDIT    texto[26]
#define TXT_PASSWORDEDIT  texto[27]
#define TXT_EDITOR        texto[28]
#define TXT_NONIVELES     texto[29]
#define TXT_NOPERSONAJE   texto[30]
#define TXT_CAJANOOBJET   texto[31]
#define TXT_CAJAOBJETIVO  texto[32]
#define TXT_NOPASSWORDED  texto[33]
#define TXT_NOCAJAS       texto[34]
#define TXT_SI            texto[35]
#define TXT_NO            texto[36]
#define TXT_TIEMPOJUEGO   texto[37]
#define TXT_PASOSJUEGO    texto[38]
#define TXT_PUNTOSJUEGO   texto[39]
#define TXT_REINIJUEGO    texto[40]
#define TXT_PASWDJUEGO    texto[41]
#define TXT_REINICIAR     texto[42]
#define TXT_PUNTOSNIVEL   texto[43]
#define TXT_ENHORABUENA   texto[44]
#define TXT_NONIVELJUEGO  texto[45]
#define TXT_SALIREDITOR   texto[46]
#define TXT_RECORDS       texto[47]
#define TXT_ENTRADAREC    texto[48]
#define TXT_NIVELACTUAL   texto[49]
#define TXT_NUEVORECORD   texto[50]
#define TXT_INTRNOMBRE    texto[51]


class Texto : public Widget
{
  // Constructor y destructor
  public:
    //Texto (CUADRO* cuadroPadre, CUADRO* cuadro, char* cadena,
    //       int x, int y, DWORD color, DWORD fuente, DWORD flags);

    Texto (CUADRO** cuadroPadre, INFOTEXTO infoTexto);

    virtual ~Texto();
    void dibujarFormateado(int reservado, ...);

  // Metodos publicos
  public:
    // Sobreescribe a Widget::dibujar()
    void dibujar();

  // Atributos publicos
  public:
    char* cadena;
    DWORD fuente;

};

#endif
