/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Ventana_h
#define Ventana_h

#include "Widget.h"
#include "Texto.h"
#include "Boton.h"
#include "CuadroTexto.h"

// Mesajes de la ventana
#define MSG_ACEPTAR       1
#define MSG_CANCELAR      2
#define MSG_SINO          4
#define MSG_SINOCAN       8
#define MSG_SI           16
#define MSG_NO           32

// Valores por defecto para la ventana
#define DF_COLORBARRATITULO   0x114477
#define DF_COLORTEXTOTITULO   0xFFFFFF
#define DF_COLORTEXTOVENTANA  0xFFFFFF
#define DF_FUENTEVENTANA      0
#define DF_FLAGSVENTANA WID_ARRASTRABLE //|WID_CENTRARX|WID_CENTRARY

/**
 * Clase Ventana heredada de la clase Boton
 */
class Ventana : public Widget {

  public:
    // Constructor y destructor
    Ventana (CUADRO** cuadroPadre, Texto* titulo, int x, int y,
             int an, int al, int flags);
    virtual ~Ventana();

    // Dibuja la ventana
    void dibujar();

    // Comprueba el estado de la ventana
    int comprobarEstado();

    // Agrega un boton a la ventana indicando su tamao
    Boton* agregarBoton(Texto* texto, int x, int y, int ancho, int alto);

    // Agrega un boton a partir de una imagen
    Boton* agregarBoton(char* nombreFichero, int x, int y);

    // Agrega un texto
    Texto* agregarTexto(Texto* cadena, int x, int y,
                        DWORD color = DF_COLORTEXTOVENTANA,
                        int fuente  = DF_FUENTEVENTANA);

    // Agrega un cuadro de texto
    CuadroTexto* agregarCuadroTexto(int x, int y, int ancho,
                                    int alto, int maxLetras);


  public:
    // Barra de titulo de la ventana
    Boton*        barraTitulo;

    // Botones
    Boton*        boton[100];       // ## A hacer: Convertir a vector de C++

    // Textos
    Texto*        texto[100];

    // Cuadros de texto
    CuadroTexto*  cuadroTexto[100];

  private:
    // Atributos de la ventana
    int colorBarraTitulo;
    int colorTextoTitulo;

    int posIniX;
    int posIniY;
    int arrastrando;

    int nBotones;                   // ## A hacer: Convertir a vector de C++
    int nTextos;
    int nCuadrosTexto;

};
#endif
