/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Widget_h
#define Widget_h

#include "defines.h"

#define Imagen Widget

#define WID_CENTRARX        1
#define WID_CENTRARY        2
#define WID_SOMBRA          4
#define WID_DETECTARRATON   8
#define WID_INVISIBLE      16
#define WID_ARRASTRABLE    32
#define WID_ALINEARDE      64
#define WID_ALINEARIZ     128
#define WID_ALINEARAR     256
#define WID_ALINEARAB     512

#define DF_COLORFONDO       0x88AACC
#define DF_COLORBORDE       0x000001
#define DF_COLORBASE        0x000000
#define DF_COLORRATON       0xFF0000
//#define DF_FLAGSBOTON       VNT_VISIBLE

/**
 * Este es el control grafico mas basico. Es la raiz desde la cual parten
 * el resto de controles, como las clases Ventana, Boton o CuadroTexto.
 */
class Widget
{
  // Constructores y destructor de la clase
  public:
    // Construye el widget indicando posicion y tamao
    Widget(CUADRO** cuadroPadre, int x, int y, int ancho, int alto);

    // Construye el widget a partir de un fichero de imagen
    Widget(CUADRO** cuadroPadre, int x, int y, char *ficheroImagen);

    // Destructor
    virtual ~Widget();

  // Metodos publicos
  public:
    // Dibujar el control en su posicion
    virtual void dibujar();

    // Detectar el raton
    virtual DWORD detectarRaton();

    // Copia el puntero del grafico de otro widget a este widget
    virtual void establecerImagen(Widget* imagen);

    // Centrar este widget sobre el widget padre
    virtual void centrar(int flags);

    // Permuta la visibilidad del widget
    virtual void visible() { flags ^= WID_INVISIBLE ; } ;

    // Obtener las posiciones x e y absolutas en la pantalla de este widget
    int xAbs(CUADRO* cuadro);
    int yAbs(CUADRO* cuadro);

  // Atributos publicos
  public:
    DWORD colorFondo;
    DWORD colorTexto;
    DWORD colorRaton;
    DWORD colorBorde;
    DWORD colorSombra;
    int   despSombra;
    DWORD flags;

    // Posicion y tamao de este widget
    CUADRO* cuadro;

    // Superficie grafica
    void* graficos;

  // Atributos protegidos
  protected:

    // Puntero estatico al widget que tiene el foco
    static void* foco;

};

#endif
